# Casino+

画像

## 自作アプリにカジノゲームを簡単に組み込もう!

- アプリにミニゲームを追加することができます
- トランプカードを使うことができます

インストール

```pubspec.yaml
dependencies:
  flutter:
    sdk: flutter
  casino_plus: // ここに追加します
```

コード例

```
// パッケージをインポートします
import 'package:casino_plus/casino_plus.dart';
```

// トランプカードのスート(マーク)は enum として定義されています

```
enum Suit {
  spade, // スペード ♠︎
  heart, // ハート ♥
  diamond, // ダイヤ ♦
  club, // クラブ ♣
}
```

// トランプカードの数字は enum として定義されています

```
enum Number {
  num1, // A
  num2, // 2
  ...
  num11, // J
  num12, // Q
  num13, // K
}
```

// トランプカード(プレイングカード)自体も enum として定義されています

```
enum PlayingCard {
  spade1, // スペードのA
  spade2, // スペードの2
  spade3, // スペードの3
  ...
  club13, // クラブのK
}
```

// トランプカードをマークや数字へ分解できます

```
// ♥5
var x = PlayingCard.heart5;
// ♥
print(x.suit);
// 5
print(x.number);
```

// ゲームで使うデッキは カードの配列 として取得できます

```
// [ ♠︎A, ♠︎2, ♠︎3 ... ♣K ]
var deck = newDeck();
```

// カード画像を表示する Widget が用意されています

```
// ♦8
var x = PlayingCard.diamond8;
// 表示するウィジェット
PlayingCardImage( x );
```

<br>

こんにちは カジノプラス の開発スタッフです  
このページをご覧いただきありがとうございます 😃

<br>

- プルリクエスト、問題の報告、意見は大歓迎です 🎉
- 協力してくれる方は、初心者/経験者を問わず、1 コミットだけや練習でも OK です
- Twitter で連絡待ってます 🐥
- 頻繁に連絡を取る方は Slack へ招待させていただきます

## メインで開発している人の Twitter

- ルビードッグ(@Rubydog725)
  https://twitter.com/Rubydog725

## 詳しくはこちらから！

注意: 作成中のページです  
https://casino-plus.github.io/
