import 'package:casino_plus/src/router/navi_state.dart' as router_state;
import 'package:casino_plus/src/router/navi_window.dart';
import 'package:casino_plus/src/router/router.dart';
import 'package:casino_plus/src/types/game_id.dart';
import 'package:flutter/material.dart';
import 'package:hooks_riverpod/hooks_riverpod.dart';
import 'package:flutter_hooks/flutter_hooks.dart';

class GameOnlinePage extends StatelessWidget {
  // ゲームID
  final GameId gameId;
  // ページを閉じるとき
  final void Function() onGamePageClose;
  const GameOnlinePage({
    required this.gameId,
    required this.onGamePageClose,
  });
  @override
  Widget build(BuildContext context) {
    final _page = _CasinoPlusOnlinePage(
      gameId: gameId,
    );
    final scaffold = Scaffold(body: _page);
    final scope = ProviderScope(child: scaffold);
    return scope;
  }
}

// ProviderScope で囲むために分離
class _CasinoPlusOnlinePage extends HookConsumerWidget {
  // ゲームID
  final GameId gameId;
  const _CasinoPlusOnlinePage({
    required this.gameId,
  });
  @override
  Widget build(BuildContext context, WidgetRef ref) {
    useEffect(() {
      WidgetsBinding.instance?.addPostFrameCallback((_) {
        debugPrint('Casino+(Online) did builded.');
        // final newState = CasinoPlusOnl(gameId: gameId);
        // ref.read(offlineState.notifier).update(newState);
        // ref.read(router).pushGamePlayNavi(PageId.gamePlay);
      });
    }, const []);
    final naviState = ref.watch(router_state.naviState);
    final naviWindow = NaviWindow(
      state: naviState,
      popPage: () {
        ref.read(router).popPage();
      },
    );
    final scaffold = Scaffold(body: naviWindow);
    final scope = ProviderScope(child: scaffold);
    return scope;
  }
}
