import 'package:casino_plus/src/types/playing_card.dart';
import 'package:casino_plus/src/types/partycake/combo.dart';
import 'package:casino_plus/src/types/partycake/dealer_step.dart';
import 'package:casino_plus/src/types/partycake/inner_piece_id.dart';
import 'package:casino_plus/src/types/partycake/outer_piece_id.dart';
import 'package:casino_plus/src/types/partycake/player_step.dart';
import 'package:casino_plus/src/types/partycake/record.dart';
import 'package:casino_plus/src/types/partycake/seat.dart';
import 'package:casino_plus/src/types/partycake/side.dart';
import 'package:uuid/uuid.dart';

const _dealerStep = DealerStep.waitingBet;

final _deck = [
  PlayingCard.spade1,
  PlayingCard.spade11,
  PlayingCard.spade12,
  PlayingCard.heart1,
  PlayingCard.heart11,
  PlayingCard.heart12,
  PlayingCard.diamond11,
  PlayingCard.diamond12,
  PlayingCard.diamond13,
  PlayingCard.club11,
  PlayingCard.club12,
  PlayingCard.club13,
];

final List<Side> _sides = [Seat.s1, Seat.s2, Seat.s3, Seat.s4].map((seat) {
  return Side(
    seat: seat,
    playerStep: PlayerStep.bet,
    chips: 27,
    handCardIds: [],
    betLevel: null,
    putCardId: null,
    lastCombo: Combo.start,
  );
}).toList();

final _innerPieceIds = [
  InnerPieceId.club,
  InnerPieceId.heart,
  InnerPieceId.joker,
  InnerPieceId.diamond,
];

final _outerPieceIds = [
  OuterPieceId.diamond12,
  OuterPieceId.club11,
  OuterPieceId.spade13,
  OuterPieceId.heart1,
];

final initialRecord = Record(
  id: const Uuid().v4(),
  deck: _deck,
  dealerStep: _dealerStep,
  sides: _sides,
  innerPieceIds: _innerPieceIds,
  outerPieceIds: _outerPieceIds,
  innerOffset: 0,
  outerOffset: 0,
);
