import 'package:casino_plus/src/host/partycake/partycake_core/inner_pieces.dart';
import 'package:casino_plus/src/host/partycake/partycake_core/make_combo.dart';
import 'package:casino_plus/src/host/partycake/partycake_core/outer_pieces.dart';
import 'package:casino_plus/src/config/cards.dart';
import 'package:casino_plus/src/types/partycake/record.dart';
import 'package:casino_plus/src/types/partycake/seat.dart';
import 'package:casino_plus/src/types/partycake/side.dart';

Record judge(Record record) {
  List<Side> newSides = [];
  for (var side in record.sides) {
    // Seat から 対応する index を取得
    final seatOffset = side.seat.rawValue - 1;
    var innerIndex = seatOffset - record.innerOffset;
    if (innerIndex < 0) {
      innerIndex += record.innerPieceIds.length;
    }
    var outerIndex = seatOffset - record.outerOffset;
    if (outerIndex < 0) {
      outerIndex += record.outerPieceIds.length;
    }
    // inner, outer, card を取得
    final innerPieceId = record.innerPieceIds[innerIndex];
    final innerPiece =
        innerPieces.firstWhere((piece) => piece.id == innerPieceId);
    final outerPieceId = record.outerPieceIds[outerIndex];
    final outerPiece =
        outerPieces.firstWhere((piece) => piece.id == outerPieceId);
    final putCardId = side.putCardId;
    final putCard = cards.firstWhere((card) => card.id == putCardId);

    // Combo を計算して新しい Side を作成
    final combo = makeCombo(
      innerSuit: innerPiece.suitId,
      outerSuit: outerPiece.suitId,
      outerNumber: outerPiece.numberId,
      cardSuit: putCard.suit,
      cardNumber: putCard.number,
      lastCombo: side.lastCombo,
    );
    final newSide = side.copyWith(
      lastCombo: combo,
    );
    newSides.add(newSide);
  }
  // 新しい Record を作成して返す
  final newRecord = record.copyWith(
    sides: newSides,
  );
  return newRecord;
}
