import 'package:casino_plus/src/apps/game_offline_page/game_offline_page.dart';
import 'package:casino_plus/src/components/url_image.dart';
import 'package:flutter/material.dart';
import 'package:casino_plus/casino_plus.dart';
import 'package:hooks_riverpod/hooks_riverpod.dart';
import 'package:riverpod/riverpod.dart';

void main() {
  final app = ProviderScope(child: TestCardImageApp());
  runApp(app);
}

class SampleParentApp extends StatelessWidget {
  @override
  Widget build(BuildContext context) {
    UrlImage.localMode = true;
    return MaterialApp(
      title: 'Casino+',
      debugShowCheckedModeBanner: false,
      home: GameOfflinePage(
        gameId: GameId.cakepoker,
        onGamePageClose: () {
          debugPrint('サンプルアプリは終了しません');
        },
      ),
    );
  }
}

class TestCardImageApp extends HookConsumerWidget {
  @override
  Widget build(BuildContext context, WidgetRef ref) {
    UrlImage.localMode = true;
    final card = ref.watch(cardState);
    return MaterialApp(
      title: 'Casino+',
      debugShowCheckedModeBanner: false,
      home: Scaffold(
        body: Column(
          children: [
            PlayingCardImage(card),
            const PlayingCardImage(PlayingCard.heart7),
            ElevatedButton(
              onPressed: () async {
                final deck = newDeck();
                for (var deckCard in deck) {
                  ref.read(cardState.notifier).update(deckCard);
                  await Future.delayed(const Duration(seconds: 1));
                }
              },
              child: const Text('Test'),
            )
          ],
        ),
      ),
    );
  }
}

class _Notifier extends StateNotifier<PlayingCard> {
  _Notifier(PlayingCard card) : super(card);
  update(PlayingCard newCard) {
    state = newCard;
  }
}

/// 公開
final cardState = StateNotifierProvider<_Notifier, PlayingCard>((ref) {
  // 初期化
  return _Notifier(PlayingCard.back);
});
