import 'package:casino_plus/src/components/url_image.dart';
import 'package:casino_plus/src/config/image_names.dart';
import 'package:casino_plus/src/pages/partycake_play/put_box.dart';
import 'package:casino_plus/src/state/partycake_ui_state.dart';
import 'package:casino_plus/src/types/partycake/seat.dart';
import 'package:flutter/material.dart';
import 'package:hooks_riverpod/hooks_riverpod.dart';

class Board extends HookConsumerWidget {
  final double width;
  final double height;
  const Board(this.width, this.height);
  @override
  Widget build(BuildContext context, WidgetRef ref) {
    final uiState = ref.watch(partycakeUiState);
    return Center(
      child: Column(
        mainAxisAlignment: MainAxisAlignment.center,
        children: [
          Row(
            mainAxisAlignment: MainAxisAlignment.spaceEvenly,
            children: [
              SizedBox(
                width: width * 0.25,
                height: width * 0.25,
                child: const PutBox(Seat.s4),
              ),
              SizedBox(
                width: width * 0.25,
                height: width * 0.25,
                child: const PutBox(Seat.s1),
              ),
            ],
          ),
          Stack(
            alignment: Alignment.center,
            children: [
              RotationTransition(
                turns: AlwaysStoppedAnimation(uiState.innerCakeDegree / 360),
                child: SizedBox(
                  width: width * 0.9,
                  height: width * 0.9,
                  child: UrlImage.assetsName(ImageNames.partycakeOuter),
                ),
              ),
              RotationTransition(
                turns: AlwaysStoppedAnimation(uiState.outerCakeDegree / 360),
                child: SizedBox(
                  width: width * 0.9 / 1.618,
                  height: width * 0.9 / 1.618,
                  child: UrlImage.assetsName(ImageNames.partycakeInner),
                ),
              ),
            ],
          ),
          Row(
            mainAxisAlignment: MainAxisAlignment.spaceEvenly,
            children: [
              SizedBox(
                width: width * 0.25,
                height: width * 0.25,
                child: const PutBox(Seat.s3),
              ),
              SizedBox(
                width: width * 0.25,
                height: width * 0.25,
                child: const PutBox(Seat.s2),
              ),
            ],
          ),
        ],
      ),
    );
  }
}
