import 'package:casino_plus/src/components/playing_card_image.dart';
import 'package:casino_plus/src/components/url_image.dart';
import 'package:casino_plus/src/config/image_names.dart';
import 'package:casino_plus/src/state/partycake_ui_state.dart';
import 'package:casino_plus/src/types/playing_card.dart';
import 'package:casino_plus/src/types/partycake/seat.dart';
import 'package:flutter/material.dart';
import 'package:hooks_riverpod/hooks_riverpod.dart';

class PutBox extends HookConsumerWidget {
  final Seat seat;
  const PutBox(this.seat);
  @override
  Widget build(BuildContext context, WidgetRef ref) {
    // TODO: - Uiの方を参照する
    final uiState = ref.watch(partycakeUiState);
    final sideUi = uiState.uiSides.firstWhere((s) => s.seat == seat);
    final PlayingCard? cardId = sideUi.putCardId;
    return Stack(
      children: [
        UrlImage.assetsName(ImageNames.partycakePutBox),
        if (cardId != null) PlayingCardImage(cardId),
      ],
    );
  }
}
