//
//
//

import 'package:casino_plus/src/host/partycake/partycake_core/initial_record.dart';
import 'package:casino_plus/src/host/partycake/record_repository.dart';
import 'package:casino_plus/src/senders/partycake/reload_record_sender.dart';
import 'package:casino_plus/src/state/game_room.dart';
import 'package:riverpod/riverpod.dart';

class GameStartPresenter {
  final Reader _read;
  GameStartPresenter(this._read);

  onOpenPartycakePalyPage() {
    final roomState = _read(gameRoomState);
    if (roomState.hostUserId == roomState.myUserId) {
      // 自分がホストだった場合
      // 新規レコードを発行して保存
      final record = initialRecord;
      final repository = RecordRepository();
      repository.saveRecord(record);
      // 他のプレイヤーへ送信
      final sender = ReloadRecordSender(_read);
      sender.sendReloadRecordMessage(record);
    }
  }
}

final gameStartPresenter = Provider((ref) => GameStartPresenter(ref.read));
