//
//
//

import 'package:casino_plus/src/presenter/partycake/showdown_presenter.dart';
import 'package:casino_plus/src/state/partycake.dart';
import 'package:casino_plus/src/state/partycake_ui_state.dart';
import 'package:casino_plus/src/types/partycake/bet_level.dart';
import 'package:casino_plus/src/types/partycake/game_message.dart';
import 'package:flutter/material.dart';
import 'package:riverpod/riverpod.dart';

class DealerDidShowdownReceiver {
  final Reader read;
  DealerDidShowdownReceiver(this.read);

  onReceiveDealerDidShowdown(GameMessage message) async {
    debugPrint('Partycake onReceiveDealerDidShowdown');
    final newGameState = PartycakeState(
      record: message.record!,
    );
    read(partycakeState.notifier).update(newGameState);

    final presenter = read(showdownPresenter);
    await presenter.showdown();

    final levels = [BetLevel.min, BetLevel.mid, BetLevel.max];
    final oldUiState = read(partycakeUiState);
    final newUiState = oldUiState.copyWith(dockBetLevels: levels);
    read(partycakeUiState.notifier).update(newUiState);
  }
}
