//
//
//

import 'package:casino_plus/src/state/partycake_ui_state.dart';
import 'package:casino_plus/src/types/playing_card.dart';
import 'package:casino_plus/src/types/partycake/game_message.dart';
import 'package:casino_plus/src/types/partycake/seat.dart';
import 'package:riverpod/riverpod.dart';

class PlayerDidPutReceiver {
  final Reader read;
  PlayerDidPutReceiver(this.read);

  onReceivePlayerDidPut(GameMessage message) async {
    final seat = message.trigger_seat!;
    // TODO: - Uiステートの方を参照する
    final oldUiState = read(partycakeUiState);
    final oldSideUiState =
        oldUiState.uiSides.firstWhere((uiSide) => uiSide.seat.rawValue == seat);
    final newSideUiState = oldSideUiState.copyWith(
      putCardId: PlayingCard.back,
      putCardDegree: 90,
    );
    var newUiSides = List.of(oldUiState.uiSides);
    newUiSides.removeWhere((uiSide) => uiSide.seat.rawValue == seat);
    newUiSides.add(newSideUiState);
    final newUiState = oldUiState.copyWith(uiSides: newUiSides);
    read(partycakeUiState.notifier).update(newUiState);
    await Future.delayed(const Duration(seconds: 1));
  }
}
