//
//
//

import 'package:casino_plus/src/host/partycake/bot_user.dart';
import 'package:casino_plus/src/state/game_room.dart';
import 'package:casino_plus/src/state/partycake.dart';
import 'package:casino_plus/src/state/partycake_ui_state.dart';
import 'package:casino_plus/src/types/partycake/bet_level.dart';
import 'package:casino_plus/src/types/partycake/game_message.dart';
import 'package:casino_plus/src/types/partycake/seat.dart';
import 'package:flutter/material.dart';
import 'package:riverpod/riverpod.dart';

class ReloadRecordReceiver {
  final Reader _read;
  ReloadRecordReceiver(this._read);
  onReceiveReloadRecord(GameMessage message) {
    debugPrint('Partycake onReceiveReloadRecord');

    final newPartycakeState = PartycakeState(
      record: message.record,
    );
    _read(partycakeState.notifier).update(newPartycakeState);

    final roomState = _read(gameRoomState);
    // ローカルで呼ばれる時は初回のみなので Bot に Bet させる
    for (var player in roomState.players) {
      if (player.userId != roomState.myUserId) {
        final bot = BotUser();
        bot.betVersion1(
          read: _read,
          botUserId: player.userId,
          record: message.record!,
          seat: SeatExt.from(player.seat)!,
        );
      }
    }

    // ローカルで呼ばれる時は初回のみなので Bet 選択肢を表示する
    final levels = [BetLevel.min, BetLevel.mid, BetLevel.max];
    final oldUiState = _read(partycakeUiState);
    final newUiState = oldUiState.copyWith(dockBetLevels: levels);
    _read(partycakeUiState.notifier).update(newUiState);
  }
}
