//
// ページIDと画面UIの紐付け
//

import 'package:casino_plus/src/router/page_id.dart';
import 'package:casino_plus/src/pages/coming_soon_play/coming_soon_play.dart';
import 'package:casino_plus/src/pages/game_play/game_play.dart';
import 'package:casino_plus/src/pages/home/home.dart';
import 'package:casino_plus/src/pages/host_lobby/host_lobby.dart';
import 'package:casino_plus/src/pages/loading/loading.dart';
import 'package:casino_plus/src/pages/not_host_entry/not_host_entry.dart';
import 'package:casino_plus/src/pages/not_host_lobby/not_host_lobby.dart';
import 'package:casino_plus/src/pages/not_host_search_room/not_host_sarch_room.dart';
import 'package:casino_plus/src/pages/partycake_play/partycake_play.dart';
import 'package:casino_plus/src/pages/partycake_score_list/score_list.dart';
import 'package:flutter/material.dart';
import 'package:hooks_riverpod/hooks_riverpod.dart';

class PageContent extends HookConsumerWidget {
  final PageId id;
  const PageContent({
    required this.id,
  });

  @override
  Widget build(BuildContext context, WidgetRef ref) {
    switch (id) {
      case PageId.loading:
        return Loading();
      case PageId.partycakePlay:
        return PartycakePlay();
      case PageId.partycakeScoreList:
        return PartycakeScoreList();
      case PageId.home:
        return Home();
      case PageId.hostEntry:
        return NotHostEntry();
      case PageId.hostLobby:
        return HostLobby();
      case PageId.notHostEntry:
        return NotHostEntry();
      case PageId.notHostSearchRoom:
        return NotHostSearchRoom();
      case PageId.notHostLobby:
        return NotHostLobby();
      case PageId.gamePlay:
        return GamePlay();
      case PageId.comingSoonPlay:
        return ComingSoonPlay();
    }
  }
}
