//
//
//

import 'package:casino_plus/src/center_client/partycake_offline_client.dart';
import 'package:casino_plus/src/state/game_room.dart';
import 'package:casino_plus/src/types/partycake/game_message.dart';
import 'package:casino_plus/src/types/partycake/game_message_type.dart';
import 'package:casino_plus/src/types/partycake/record.dart';
import 'package:riverpod/riverpod.dart';

class DealerDidShuffleSender {
  final Reader read;
  DealerDidShuffleSender(this.read);

  sendDealerDidShuffleMessgae(Record record) async {
    final state = read(gameRoomState);
    final userIds = state.players.map((player) => player.userId).toList();
    final message = GameMessage(
      type: GameMessageType.dealerDidShuffle,
      from_user_id: state.myUserId,
      to_user_ids: userIds,
      players: null,
      host_user_id: null,
      record: record,
      trigger_seat: null,
      put_card_id: null,
      bet_level: null,
    );
    final client = read(centerClientOffline);
    client.send(message);
  }
}
