import 'package:casino_plus/src/types/partycake/record.dart';
import 'package:riverpod/riverpod.dart';

/// 構造
class PartycakeState {
  final Record? record;

  const PartycakeState({
    required this.record,
  });
}

/// バインド
class _Notifier extends StateNotifier<PartycakeState> {
  _Notifier(PartycakeState state) : super(state);
  update(PartycakeState state) {
    this.state = state;
  }
}

/// 公開
final partycakeState = StateNotifierProvider<_Notifier, PartycakeState>((ref) {
  // 初期化
  const initialState = PartycakeState(
    record: null,
  );
  return _Notifier(initialState);
});
