import 'package:casino_plus/src/types/playing_card.dart';
import 'package:casino_plus/src/types/partycake/seat.dart';
import 'package:freezed_annotation/freezed_annotation.dart';
part 'partycake_side_ui_state.freezed.dart';
part 'partycake_side_ui_state.g.dart';

@freezed
class PartycakeSideUiState with _$PartycakeSideUiState {
  const PartycakeSideUiState._();

  // ignore: invalid_annotation_target
  @JsonSerializable(fieldRename: FieldRename.snake)
  factory PartycakeSideUiState({
    @SeatConverter() required Seat seat,
    @PlayingCardConverter() required PlayingCard? putCardId,
    required double putCardDegree,
  }) = _PartycakeSideUiState;

  factory PartycakeSideUiState.fromJson(Map<String, dynamic> json) =>
      _$PartycakeSideUiStateFromJson(json);
}
