//
//
//

import 'package:casino_plus/src/types/playing_card.dart';
import 'package:casino_plus/src/types/partycake/dealer_step.dart';
import 'package:casino_plus/src/types/partycake/inner_piece_id.dart';
import 'package:casino_plus/src/types/partycake/outer_piece_id.dart';

import 'side.dart';
import 'package:freezed_annotation/freezed_annotation.dart';
part 'record.freezed.dart';
part 'record.g.dart';

@freezed
class Record with _$Record {
  const Record._();

  // ignore: invalid_annotation_target
  @JsonSerializable(fieldRename: FieldRename.snake)
  factory Record({
    required String id,
    @PlayingCardConverter() required List<PlayingCard> deck,
    @DealerStepConverter() required DealerStep dealerStep,
    required List<Side> sides,
    @InnerPieceIdConverter() required List<InnerPieceId> innerPieceIds,
    @OuterPieceIdConverter() required List<OuterPieceId> outerPieceIds,
    required int innerOffset,
    required int outerOffset,
  }) = _Record;

  factory Record.fromJson(Map<String, dynamic> json) => _$RecordFromJson(json);
}
